gi-glib-2.0.24: GLib bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GLib.Structs.VariantType

Contents

- Exported types
- Methods
  - Overloaded methods
  - checked_
  - copy
  - dupString
  - element
  - equal
  - first
  - free
  - getStringLength
  - hash
  - isArray
  - isBasic
  - isContainer
  - isDefinite
  - isDictEntry
  - isMaybe
  - isSubtypeOf
  - isTuple
  - isVariant
  - key
  - nItems
  - new
  - newArray
  - newDictEntry
  - newMaybe
  - newTuple
  - next
  - stringGetDepth_
  - stringIsValid
  - stringScan
  - value

Description

This section introduces the GVariant type system. It is based, in large part, on the D-Bus type system, with two major changes and some minor lifting of restrictions. The D-Bus specification, therefore, provides a significant amount of information that is useful when working with GVariant.

The first major change with respect to the D-Bus type system is the introduction of maybe (or "nullable") types. Any type in GVariant can be converted to a maybe type, in which case, "nothing" (or "null") becomes a valid value. Maybe types have been added by introducing the character "m" to type strings.

The second major change is that the GVariant type system supports the concept of "indefinite types" -- types that are less specific than the normal types found in D-Bus. For example, it is possible to speak of "an array of any type" in GVariant, where the D-Bus type system would require you to speak of "an array of integers" or "an array of strings". Indefinite types have been added by introducing the characters "*", "?" and "r" to type strings.

Finally, all arbitrary restrictions relating to the complexity of types are lifted along with the restriction that dictionary entries may only appear nested inside of arrays.

Just as in D-Bus, GVariant types are described with strings ("type strings"). Subject to the differences mentioned above, these strings are of the same form as those found in DBus. Note, however: D-Bus always works in terms of messages and therefore individual type strings appear nowhere in its interface. Instead, "signatures" are a concatenation of the strings of the type of each argument in a message. GVariant deals with single values directly so GVariant type strings always describe the type of exactly one value. This means that a D-Bus signature string is generally not a valid GVariant type string -- except in the case that it is the signature of a message containing exactly one argument.

An indefinite type is similar in spirit to what may be called an abstract type in other type systems. No value can exist that has an indefinite type as its type, but values can exist that have types that are subtypes of indefinite types. That is to say, `variantGetType` will never return an indefinite type, but calling `variantIsOfType` with an indefinite type may return `True`. For example, you cannot have a value that represents "an array of no particular type", but you can have an "array of integers" which certainly matches the type of "an array of no particular type", since "array of integers" is a subtype of "array of no particular type".

This is similar to how instances of abstract classes may not directly exist in other type systems, but instances of their non-abstract subtypes may. For example, in GTK, no object that has the type of `GtkBin` can exist (since `GtkBin` is an abstract class), but a `GtkWindow` can certainly be instantiated, and you would say that the `GtkWindow` is a `GtkBin` (since `GtkWindow` is a subclass of `GtkBin`).

## GVariant Type Strings

A GVariant type string can be any of the following:

- any basic type string (listed below)
- "v", "r" or "*"
- one of the characters 'a' or 'm', followed by another type string
- the character '(', followed by a concatenation of zero or more other type strings, followed by the character ')'
- the character '{', followed by a basic type string (see below), followed by another type string, followed by the character '}'

A basic type string describes a basic type (as per `variantTypeIsBasic`) and is always a single character in length. The valid basic type strings are "b", "y", "n", "q", "i", "u", "x", "t", "h", "d", "s", "o", "g" and "?".

The above definition is recursive to arbitrary depth. "aaaaai" and "(ui(nq((y)))s)" are both valid type strings, as is "a(aa(ui)(qna{ya(yd)}))". In order to not hit memory limits, `GVariant` imposes a limit on recursion depth of 65 nested containers. This is the limit in the D-Bus specification (64) plus one to allow a `GDBusMessage` to be nested in a top-level tuple.

The meaning of each of the characters is as follows:

- `b`: the type string of `G_VARIANT_TYPE_BOOLEAN`; a boolean value.
- `y`: the type string of `G_VARIANT_TYPE_BYTE`; a byte.
- `n`: the type string of `G_VARIANT_TYPE_INT16`; a signed 16 bit integer.
- `q`: the type string of `G_VARIANT_TYPE_UINT16`; an unsigned 16 bit integer.
- `i`: the type string of `G_VARIANT_TYPE_INT32`; a signed 32 bit integer.
- `u`: the type string of `G_VARIANT_TYPE_UINT32`; an unsigned 32 bit integer.
- `x`: the type string of `G_VARIANT_TYPE_INT64`; a signed 64 bit integer.
- `t`: the type string of `G_VARIANT_TYPE_UINT64`; an unsigned 64 bit integer.
- `h`: the type string of `G_VARIANT_TYPE_HANDLE`; a signed 32 bit value that, by convention, is used as an index into an array of file descriptors that are sent alongside a D-Bus message.
- `d`: the type string of `G_VARIANT_TYPE_DOUBLE`; a double precision floating point value.
- `s`: the type string of `G_VARIANT_TYPE_STRING`; a string.
- `o`: the type string of `G_VARIANT_TYPE_OBJECT_PATH`; a string in the form of a D-Bus object path.
- `g`: the type string of `G_VARIANT_TYPE_SIGNATURE`; a string in the form of a D-Bus type signature.
- `?`: the type string of `G_VARIANT_TYPE_BASIC`; an indefinite type that is a supertype of any of the basic types.
- `v`: the type string of `G_VARIANT_TYPE_VARIANT`; a container type that contain any other type of value.
- `a`: used as a prefix on another type string to mean an array of that type; the type string "ai", for example, is the type of an array of signed 32-bit integers.
- `m`: used as a prefix on another type string to mean a "maybe", or "nullable", version of that type; the type string "ms", for example, is the type of a value that maybe contains a string, or maybe contains nothing.
- `()`: used to enclose zero or more other concatenated type strings to create a tuple type; the type string "(is)", for example, is the type of a pair of an integer and a string.
- `r`: the type string of `G_VARIANT_TYPE_TUPLE`; an indefinite type that is a supertype of any tuple type, regardless of the number of items.
- `{}`: used to enclose a basic type string concatenated with another type string to create a dictionary entry type, which usually appears inside of an array to form a dictionary; the type string "a{sd}", for example, is the type of a dictionary that maps strings to double precision floating point values.

The first type (the basic type) is the key type and the second type is the value type. The reason that the first type is restricted to being a basic type is so that it can easily be hashed.

- `*`: the type string of `G_VARIANT_TYPE_ANY`; the indefinite type that is a supertype of all types. Note that, as with all type strings, this character represents exactly one type. It cannot be used inside of tuples to mean "any number of items".

Any type string of a container that contains an indefinite type is, itself, an indefinite type. For example, the type string "a*" (corresponding to `G_VARIANT_TYPE_ARRAY`) is an indefinite type that is a supertype of every array type. "(*s)" is a supertype of all tuples that contain exactly two items where the second item is a string.

"a{?*}" is an indefinite type that is a supertype of all arrays containing dictionary entries where the key is any basic type and the value is any type at all. This is, by definition, a dictionary, so this type string corresponds to `G_VARIANT_TYPE_DICTIONARY`. Note that, due to the restriction that the key of a dictionary entry must be a basic type, "{**}" is not a valid type string.

Synopsis

- newtype VariantType = VariantType (ManagedPtr VariantType)
- variantTypeChecked_ :: (HasCallStack, MonadIO m) => Text -> m VariantType
- variantTypeCopy :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeDupString :: (HasCallStack, MonadIO m) => VariantType -> m Text
- variantTypeElement :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeEqual :: (HasCallStack, MonadIO m) => VariantType -> VariantType -> m Bool
- variantTypeFirst :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeFree :: (HasCallStack, MonadIO m) => VariantType -> m ()
- variantTypeGetStringLength :: (HasCallStack, MonadIO m) => VariantType -> m Word64
- variantTypeHash :: (HasCallStack, MonadIO m) => VariantType -> m Word32
- variantTypeIsArray :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsBasic :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsContainer :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsDefinite :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsDictEntry :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsMaybe :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsSubtypeOf :: (HasCallStack, MonadIO m) => VariantType -> VariantType -> m Bool
- variantTypeIsTuple :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeIsVariant :: (HasCallStack, MonadIO m) => VariantType -> m Bool
- variantTypeKey :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeNItems :: (HasCallStack, MonadIO m) => VariantType -> m Word64
- variantTypeNew :: (HasCallStack, MonadIO m) => Text -> m VariantType
- variantTypeNewArray :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeNewDictEntry :: (HasCallStack, MonadIO m) => VariantType -> VariantType -> m VariantType
- variantTypeNewMaybe :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeNewTuple :: (HasCallStack, MonadIO m) => [VariantType] -> m VariantType
- variantTypeNext :: (HasCallStack, MonadIO m) => VariantType -> m VariantType
- variantTypeStringGetDepth_ :: (HasCallStack, MonadIO m) => Text -> m Word64
- variantTypeStringIsValid :: (HasCallStack, MonadIO m) => Text -> m Bool
- variantTypeStringScan :: (HasCallStack, MonadIO m) => Text -> Maybe Text -> m (Bool, Text)
- variantTypeValue :: (HasCallStack, MonadIO m) => VariantType -> m VariantType

# Exported types

newtype VariantType Source #

Memory-managed wrapper type.

Constructors

VariantType (ManagedPtr VariantType) |

#### Instances

Instances details

Eq VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType Methods (==) :: VariantType -> VariantType -> Bool # (/=) :: VariantType -> VariantType -> Bool #
IsGValue VariantType Source # | Convert `VariantType` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.GLib.Structs.VariantType Methods toGValue :: VariantType -> IO GValue Source # fromGValue :: GValue -> IO VariantType Source #
ManagedPtrNewtype VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType Methods toManagedPtr :: VariantType -> ManagedPtr VariantType Source #
TypedObject VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType Methods glibType :: IO GType Source #
GBoxed VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType
HasParentTypes VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType
type ParentTypes VariantType Source # |
Instance details Defined in GI.GLib.Structs.VariantType type ParentTypes VariantType = '[] :: [Type]

# Methods

## Overloaded methods

## checked_

variantTypeChecked_ :: (HasCallStack, MonadIO m) => Text -> m VariantType Source #

No description available in the introspection data.

## copy

variantTypeCopy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m VariantType | Returns: a new `VariantType` Since 2.24

Makes a copy of a `VariantType`. It is appropriate to call `variantTypeFree` on the return value. `type` may not be `Nothing`.

## dupString

variantTypeDupString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Text | Returns: the corresponding type string Since 2.24

Returns a newly-allocated copy of the type string corresponding to `type`. The returned string is nul-terminated. It is appropriate to call `free` on the return value.

## element

variantTypeElement Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: an array or maybe `VariantType`
-> m VariantType | Returns: the element type of `type` Since 2.24

Determines the element type of an array or maybe type.

This function may only be used with array or maybe types.

## equal

variantTypeEqual Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type1`: a `VariantType`
-> VariantType | `type2`: a `VariantType`
-> m Bool | Returns: `True` if `type1` and `type2` are exactly equal Since 2.24

Compares `type1` and `type2` for equality.

Only returns `True` if the types are exactly equal. Even if one type is an indefinite type and the other is a subtype of it, `False` will be returned if they are not exactly equal. If you want to check for subtypes, use `variantTypeIsSubtypeOf`.

The argument types of `type1` and `type2` are only `gconstpointer` to allow use with `HashTable` without function pointer casting. For both arguments, a valid `VariantType` must be provided.

## first

variantTypeFirst Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a tuple or dictionary entry `VariantType`
-> m VariantType | Returns: the first item type of `type`, or `Nothing` Since 2.24

Determines the first item type of a tuple or dictionary entry type.

This function may only be used with tuple or dictionary entry types, but must not be used with the generic tuple type `G_VARIANT_TYPE_TUPLE`.

In the case of a dictionary entry type, this returns the type of the key.

`Nothing` is returned in case of `type` being `G_VARIANT_TYPE_UNIT`.

This call, together with `variantTypeNext` provides an iterator interface over tuple and dictionary entry types.

## free

variantTypeFree Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`, or `Nothing`
-> m () |

Frees a `VariantType` that was allocated with `variantTypeCopy`, `variantTypeNew` or one of the container type constructor functions.

In the case that `type` is `Nothing`, this function does nothing.

Since 2.24

## getStringLength

variantTypeGetStringLength Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Word64 | Returns: the length of the corresponding type string Since 2.24

Returns the length of the type string corresponding to the given `type`. This function must be used to determine the valid extent of the memory region returned by `g_variant_type_peek_string()`.

## hash

variantTypeHash Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Word32 | Returns: the hash value Since 2.24

Hashes `type`.

The argument type of `type` is only `gconstpointer` to allow use with `HashTable` without function pointer casting. A valid `VariantType` must be provided.

## isArray

variantTypeIsArray Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is an array type Since 2.24

Determines if the given `type` is an array type. This is true if the type string for `type` starts with an 'a'.

This function returns `True` for any indefinite type for which every definite subtype is an array type -- `G_VARIANT_TYPE_ARRAY`, for example.

## isBasic

variantTypeIsBasic Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a basic type Since 2.24

Determines if the given `type` is a basic type.

Basic types are booleans, bytes, integers, doubles, strings, object paths and signatures.

Only a basic type may be used as the key of a dictionary entry.

This function returns `False` for all indefinite types except `G_VARIANT_TYPE_BASIC`.

## isContainer

variantTypeIsContainer Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a container type Since 2.24

Determines if the given `type` is a container type.

Container types are any array, maybe, tuple, or dictionary entry types plus the variant type.

This function returns `True` for any indefinite type for which every definite subtype is a container -- `G_VARIANT_TYPE_ARRAY`, for example.

## isDefinite

variantTypeIsDefinite Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is definite Since 2.24

Determines if the given `type` is definite (ie: not indefinite).

A type is definite if its type string does not contain any indefinite type characters ('*', '?', or 'r').

A `GVariant` instance may not have an indefinite type, so calling this function on the result of `variantGetType` will always result in `True` being returned. Calling this function on an indefinite type like `G_VARIANT_TYPE_ARRAY`, however, will result in `False` being returned.

## isDictEntry

variantTypeIsDictEntry Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a dictionary entry type Since 2.24

Determines if the given `type` is a dictionary entry type. This is true if the type string for `type` starts with a '{'.

This function returns `True` for any indefinite type for which every definite subtype is a dictionary entry type -- `G_VARIANT_TYPE_DICT_ENTRY`, for example.

## isMaybe

variantTypeIsMaybe Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a maybe type Since 2.24

Determines if the given `type` is a maybe type. This is true if the type string for `type` starts with an 'm'.

This function returns `True` for any indefinite type for which every definite subtype is a maybe type -- `G_VARIANT_TYPE_MAYBE`, for example.

## isSubtypeOf

variantTypeIsSubtypeOf Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> VariantType | `supertype`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a subtype of `supertype` Since 2.24

Checks if `type` is a subtype of `supertype`.

This function returns `True` if `type` is a subtype of `supertype`. All types are considered to be subtypes of themselves. Aside from that, only indefinite types can have subtypes.

## isTuple

variantTypeIsTuple Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is a tuple type Since 2.24

Determines if the given `type` is a tuple type. This is true if the type string for `type` starts with a '(' or if `type` is `G_VARIANT_TYPE_TUPLE`.

This function returns `True` for any indefinite type for which every definite subtype is a tuple type -- `G_VARIANT_TYPE_TUPLE`, for example.

## isVariant

variantTypeIsVariant Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType`
-> m Bool | Returns: `True` if `type` is the variant type Since 2.24

Determines if the given `type` is the variant type.

## key

variantTypeKey Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a dictionary entry `VariantType`
-> m VariantType | Returns: the key type of the dictionary entry Since 2.24

Determines the key type of a dictionary entry type.

This function may only be used with a dictionary entry type. Other than the additional restriction, this call is equivalent to `variantTypeFirst`.

## nItems

variantTypeNItems Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a tuple or dictionary entry `VariantType`
-> m Word64 | Returns: the number of items in `type` Since 2.24

Determines the number of items contained in a tuple or dictionary entry type.

This function may only be used with tuple or dictionary entry types, but must not be used with the generic tuple type `G_VARIANT_TYPE_TUPLE`.

In the case of a dictionary entry type, this function will always return 2.

## new

variantTypeNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `typeString`: a valid GVariant type string
-> m VariantType | Returns: a new `VariantType`

Creates a new `VariantType` corresponding to the type string given by `typeString`. It is appropriate to call `variantTypeFree` on the return value.

It is a programmer error to call this function with an invalid type string. Use `variantTypeStringIsValid` if you are unsure.

Since: 2.24

## newArray

variantTypeNewArray Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `element`: a `VariantType`
-> m VariantType | Returns: a new array `VariantType` Since 2.24

Constructs the type corresponding to an array of elements of the type `type`.

It is appropriate to call `variantTypeFree` on the return value.

## newDictEntry

variantTypeNewDictEntry Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `key`: a basic `VariantType`
-> VariantType | `value`: a `VariantType`
-> m VariantType | Returns: a new dictionary entry `VariantType` Since 2.24

Constructs the type corresponding to a dictionary entry with a key of type `key` and a value of type `value`.

It is appropriate to call `variantTypeFree` on the return value.

## newMaybe

variantTypeNewMaybe Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `element`: a `VariantType`
-> m VariantType | Returns: a new maybe `VariantType` Since 2.24

Constructs the type corresponding to a maybe instance containing type `type` or Nothing.

It is appropriate to call `variantTypeFree` on the return value.

## newTuple

variantTypeNewTuple Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [VariantType] | `items`: an array of `GVariantTypes`, one for each item
-> m VariantType | Returns: a new tuple `VariantType` Since 2.24

Constructs a new tuple type, from `items`.

`length` is the number of items in `items`, or -1 to indicate that `items` is `Nothing`-terminated.

It is appropriate to call `variantTypeFree` on the return value.

## next

variantTypeNext Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a `VariantType` from a previous call
-> m VariantType | Returns: the next `VariantType` after `type`, or `Nothing` Since 2.24

Determines the next item type of a tuple or dictionary entry type.

`type` must be the result of a previous call to `variantTypeFirst` or `variantTypeNext`.

If called on the key type of a dictionary entry then this call returns the value type. If called on the value type of a dictionary entry then this call returns `Nothing`.

For tuples, `Nothing` is returned when `type` is the last item in a tuple.

## stringGetDepth_

variantTypeStringGetDepth_ :: (HasCallStack, MonadIO m) => Text -> m Word64 Source #

No description available in the introspection data.

## stringIsValid

variantTypeStringIsValid Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `typeString`: a pointer to any string
-> m Bool | Returns: `True` if `typeString` is exactly one valid type string Since 2.24

Checks if `typeString` is a valid GVariant type string. This call is equivalent to calling `variantTypeStringScan` and confirming that the following character is a nul terminator.

## stringScan

variantTypeStringScan Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `string`: a pointer to any string
-> Maybe Text | `limit`: the end of `string`, or `Nothing`
-> m (Bool, Text) | Returns: `True` if a valid type string was found

Scan for a single complete and valid GVariant type string in `string`. The memory pointed to by `limit` (or bytes beyond it) is never accessed.

If a valid type string is found, `endptr` is updated to point to the first character past the end of the string that was found and `True` is returned.

If there is no valid type string starting at `string`, or if the type string does not end before `limit` then `False` is returned.

For the simple case of checking if a string is a valid type string, see `variantTypeStringIsValid`.

Since: 2.24

## value

variantTypeValue Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> VariantType | `type`: a dictionary entry `VariantType`
-> m VariantType | Returns: the value type of the dictionary entry Since 2.24

Determines the value type of a dictionary entry type.

This function may only be used with a dictionary entry type.